use crate::database::get_nodes_as_html_tabe;
use salvo::prelude::*;

#[handler]
async fn homepage() -> String {
    get_nodes_as_html_tabe()
}

#[handler]
async fn sign(req: &mut Request) -> String {
    let pubkey = match req.query::<String>("pubkey") {
        Some(k) => k,
        None => return "pubkey must be specified as GET param".to_string(),
    };

    let something = match req.query::<String>("something") {
        Some(k) => k,
        None => return "something must be specified as GET param".to_string(),
    };

    match crate::database::sign_message_with_key(&pubkey, &something) {
        Ok(s) => s,
        Err(e) => e.to_string(),
    }
}

pub async fn start() {
    let acceptor = TcpListener::new("0.0.0.0:5800").bind().await;
    let router = Router::new()
        .get(homepage)
        .push(Router::with_path("sign").get(sign));
    println!("{:?}", router);
    Server::new(acceptor).serve(router).await;
}
